<#ibizinclude>
../@MACRO/CONTROL/CONTROL_HEADER.tsx.ftl
</#ibizinclude>


    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getData(): any {
        return {};
    }

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public created() {
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                const refs: any = this.$refs;
                Object.keys(refs).forEach((name: string) => {
                    this.viewState.next({ tag: name, action: action, data: data });
                });
            });
        }
    }

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public destroyed() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        <#if destroyed_block??>
        ${destroyed_block}
        </#if>
    }

    /**
     * 内容绘制
     *
     * @returns
     * @memberof Pickupviewpanel
     */
    public render() {
        return (
            <div class='dashboard'>
                <row>
            <#list ctrl.getPSPortlets() as portlet>
            <#if portlet.getPortletType?? && portlet.getPortletType()??>

                <#assign layout='TABLE_24COL'><#if portlet.getPSLayoutPos()??><#if portlet.getPSLayoutPos().getParentPSLayout()??><#assign layout='${portlet.getPSLayoutPos().getParentPSLayout().getLayout()}'></#if></#if>
                <#assign LayoutPos = portlet.getPSLayoutPos()>
                <#if layout == 'TABLE_24COL' && LayoutPos??>
                <i-col<#if LayoutPos.getColXS() != -1> xs={{ span: ${LayoutPos.getColXS()}, offset: <#if LayoutPos.getColXSOffset() != -1>${LayoutPos.getColXSOffset()}<#else>0</#if> }}</#if><#if LayoutPos.getColSM() != -1> sm={{ span: ${LayoutPos.getColSM()}, offset: <#if LayoutPos.getColSMOffset() != -1>${LayoutPos.getColSMOffset()}<#else>0</#if> }}</#if><#if LayoutPos.getColMD() != -1> md={{ span: ${LayoutPos.getColMD()}, offset: <#if LayoutPos.getColMDOffset() != -1>${LayoutPos.getColMDOffset()}<#else>0</#if> }}</#if><#if LayoutPos.getColLG() != -1> lg={{ span: ${LayoutPos.getColLG()}, offset: <#if LayoutPos.getColLGOffset() != -1>${LayoutPos.getColLGOffset()}<#else>0</#if> }}</#if>>
                    <card bordered={false} dis-hover={true} padding={0}>
                        <#if portlet.isShowTitleBar()>
                        <p slot='title'>
                            ${portlet.getTitle()}
                        </p>
                        <a slot='extra'>
                        </a>
                        </#if> 
                        <span>
                            ${P.getCtrlCode(portlet, 'CONTROL.html').code}
                        </span>
                    </card>
                </i-col>
                <#else>
                <card bordered={false} dis-hover={true} padding={0}>
                    <#if portlet.isShowTitleBar()>
                    <p slot='title'>
                        ${portlet.getTitle()}
                    </p>
                    <a slot='extra'>
                    </a>
                    </#if> 
                    <span>
                        ${P.getCtrlCode(portlet, 'CONTROL.html').code}
                    </span>
                </card>
                </#if>
                <#if layout == 'FLEX'>
                    <card bordered={false} dis-hover={true} padding={0}>
                        <#if portlet.isShowTitleBar()>
                        <p slot='title'>
                            ${portlet.getTitle()}
                        </p>
                        <a slot='extra'>
                        </a>
                        </#if> 
                        <span>
                            ${P.getCtrlCode(portlet, 'CONTROL.html').code}
                        </span>
                    </card>
                </#if>
            </#if>
            </#list>
                </row>
            </div>
        );
    }

}